Package frc.robot.subsystems.swervedrive2.swervelib.parser.json

## Class ModuleJson

- java.lang.Object
- - frc.robot.subsystems.swervedrive2.swervelib.parser.json.ModuleJson

-     public class ModuleJson
      extends Object

  `SwerveModule` JSON parsed class. Used to access the JSON data.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `boolean` | `absoluteEncoderInverted` | Absolute encoder inversion state.
    `double` | `absoluteEncoderOffset` | Absolute encoder offset from 0 in degrees.
    `DeviceJson` | `angle` | Angle motor device configuration.
    `DeviceJson` | `drive` | Drive motor device configuration.
    `DeviceJson` | `encoder` | Absolute encoder device configuration.
    `BoolMotorJson` | `inverted` | Defines which motors are inverted.
    `LocationJson` | `location` | The location of the swerve module from the center of the robot in inches.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ModuleJson()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SwerveModuleConfiguration` | `createModuleConfiguration​(PIDFConfig anglePIDF, PIDFConfig velocityPIDF, double maxSpeed, SwerveModulePhysicalCharacteristics physicalCharacteristics)` | Create the swerve module configuration based off of parsed data.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### drive

          public DeviceJson drive

      Drive motor device configuration.

    - #### angle

          public DeviceJson angle

      Angle motor device configuration.

    - #### encoder

          public DeviceJson encoder

      Absolute encoder device configuration.

    - #### inverted

          public BoolMotorJson inverted

      Defines which motors are inverted.

    - #### absoluteEncoderOffset

          public double absoluteEncoderOffset

      Absolute encoder offset from 0 in degrees.

    - #### absoluteEncoderInverted

          public boolean absoluteEncoderInverted

      Absolute encoder inversion state.

    - #### location

          public LocationJson location

      The location of the swerve module from the center of the robot in inches.

  - ### Constructor Detail

    - #### ModuleJson

          public ModuleJson()

  - ### Method Detail

    - #### createModuleConfiguration

          public SwerveModuleConfiguration createModuleConfiguration​(PIDFConfig anglePIDF,
                                                                     PIDFConfig velocityPIDF,
                                                                     double maxSpeed,
                                                                     SwerveModulePhysicalCharacteristics physicalCharacteristics)

      Create the swerve module configuration based off of parsed data.
      Parameters:
        `anglePIDF` - The PIDF values for the angle motor.
        `velocityPIDF` - The velocity PIDF values for the drive motor.
        `maxSpeed` - The maximum speed of the robot in meters per second.
        `physicalCharacteristics` - Physical characteristics of the swerve module.
      Returns:
        `SwerveModuleConfiguration` based on the provided data and parsed data.